        page
******************************************************
** Copyright 2006 CMI Productions.                  **
** Lots of rights reserved.                         **
** Free for personal use as long as this copyright  **
** message is maintained in the source and the LCD  **
** copyright message is also preserved.  Commercial **
** use prohibited without CMIs written concent.     **
******************************************************


        org     apram        ; the place for our variables

* BASIC MEMORY MAP:
* 040-04f: Reserved for MON08
* 050-1bf: App RAM
* 1c0-23f: Reserved for MON08
*
* ***********WARNING WARNING WARNING WARNING WARNING WARNING **********
* ***********WARNING WARNING WARNING WARNING WARNING WARNING **********
*
* The first 64 bytes of RAM are very special, they get used twice.
* The variables commented with ;* are 64 bytes of RAM that are re-used
* by the sensor sensor calibration routines where I temporarily need
* a workspace that big to hold IDs.
*
* Note also that I try to make the distinction between RAM that is in
* the range $40-$ff and then the rest from $100 on.  The P&E assembler
* does not know how to check for this automatically, so this needs to
* be a manual check.  I do this by issuing an 8-bit address only
* instruction to the variable ramff.  If I go over $00ff, then the
* compiler will generate an error message.
*
* **************  AS SUCH, ALL THESE VARAIBLES WILL GET  **************
* ************** TRASHED DURING THE CALIBRATION ROUTINE. **************
*
* Don't mess with the special area below unless you really have to.
* If you must, make sure that you maintain a block of at least 64 bytes that
* arn't needed during the calibration routine and also don't need to keep
* their value after the calibration routine starts.
*
* The full contents of this memory is used multiple times during the
* sensor calibration process to store temporary data while flash is
* erased and re-written.
*

***************** START OF SUPER-SPECIAL 64-BYTE AREA ********************

msg:    rmb     32              ;* the message to display/transmit
cumwdr: rmb     16              ;* cumulative wind direction readings (5-minute)

temphi: rmb     1               ;* Current high temperature (24-hour)
templo: rmb     1               ;* Current low temperature (24-hour)
lastws: rmb     4               ;* last wind speed reading (32-bit)
cumws2: rmb     2               ;* cumulative wind speed readings (5-minute)
cumtmp: rmb     2               ;* cumulative temperature readings (5-minute)
maxws:  rmb     2               ;* maximum wind speed readings (5-minute)
cumcnt: rmb     1               ;* cumulative sample counter (120)
avgwdr: rmb     1               ;* averaged wind direction (5-minute)

cnv2a:  rmb     2               ;* value to convert

****************** END OF SUPER-SPECIAL 64-BYTE AREA *********************

divdnd: rmb     2               ;16/8 divide routine 16-bit dividend
divsor: rmb     1               ;16/8 divide routine 8-bit divisor
quotnt: rmb     2               ;16/8 divide routine 16-bit quotient
remndr: rmb     1               ;16/8 divide routine 8-bit remainder


temp:   rmb     1               ; Temporary stuff
temp2:  rmb     1               ; More temporary stuff
cntr:   rmb     1               ; general counter
iswcnt: rmb     1               ; switch command count

i_fam:  rmb     1               ; family code for searches
i_fam1: rmb     1               ; iButton family code Rx true
i_fam2: rmb     1               ; iButton family code Rx inverted
flg12:  rmb     1               ; 1st/2nd bit ack flag

rdtemp: rmb     1               ; the read temperature
ddtemp: rmb     1               ; the displayed temperature (rdtemp or hmtmp)
rdcnt1: rmb     4               ; wind speed counter value
winspd: rmb     2               ; wind speed counter difference
windir: rmb     1               ; wind direction index

crc16h: rmb     1               ; CRC MSB
crc16l: rmb     1               ; CRC LSB
crcdat: rmb     1               ; CRC dat storage
crccnt: rmb     1               ; CRC bit counter
crchld: rmb     1               ; CRC holding register
crc8:   rmb     1               ; 8-bit CRC

ruftim: rmb     1               ; .1 second SW timer counter (interrupt driven)
year:   rmb     1               ; real-time year
month:  rmb     1               ; real-time month
day:    rmb     1               ; real-time day
hrs:    rmb     1               ; real-time hours
mins:   rmb     1               ; real-time minutes
secs:   rmb     1               ; real-time seconds
ssecs:  rmb     1               ; real-time sub-seconds
lhrs:   rmb     1               ; Hour in Local time

curkey: rmb     1               ; current keycode
zfill:  rmb     1               ; Zero fill flag (1=fill, 0=don't)

yesthi: rmb     1               ; yesterdays hi temp
yestlo: rmb     1               ; yesterdays lo temp
yestgs: rmb     2               ; yesterdays Gust
todygs: rmb     2               ; Todays Gust

tsamp:  rmb     1               ; Temperature sample count
wsamp:  rmb     1               ; Wind speed sample count
irqseq: rmb     1               ; IRQ sequencer counter

ranref: rmb     2               ; rain reference # (since midnight)
rancnt: rmb     2               ; current rain counter
rantdy: rmb     2               ; rain today
ranyst: rmb     2               ; rain yesterday
ranmth: rmb     2               ; rain yesterday

atemp:  rmb     4               ; ASCII temporary value
msgptr: rmb     1               ; SCI transmit message pointer

; The three error bytes below hold two pieces of information.  Bits 0-5 are
; counters that count comm errors for each kind of transaction.  They get
; cleared on power-up and then increment as errors happen.  The upper two
; bits are error flags so that the sampling and display routines know if
; the most recently fetched data was in error and then know not to display
; the data.  For wind direction and temperature only the MSB is used to
; flag bad data.  For wind speed, two successive good samples are needed in
; order to determine the wind data.  When an error happens, both MSBs are
; set and one is cleared each time a new sample is acquired.  Once both are
; cleared, then I know there is good data from which to determine the last
; wind speed value.

errtmp: rmb     1               ; Error counter for temperature readings
errspd: rmb     1               ; Error counter for wind speed
errdir: rmb     1               ; Error counter for wind direction
errran: rmb     1               ; Error counter for rain guage
errhum: rmb     1               ; Error counter for humidity
errdd:  rmb     2               ; Error counter for displayed temperature
ran1hr: rmb     2               ; rain past hour
rirgot: rmb     1               ; Ram-based Got rainguage flag
; Data logging variables

ds94pg: rmb     1               ; the page to read/write

; semaphores between the mainline code and the interrupt routines.

rtchld: rmb     1               ; Hold RTC increments (during time set)
wxhold: rmb     1               ; Hold off getting weather samples
newdat: rmb     1               ; New data flag

; mainline-only variables.

lkey:   rmb     1               ; Last key processed
cdisp:  rmb     1               ; current screen to display
rdy2:   rmb     1               ; ready flag for LCD polling
dsecs:  rmb     1               ; delay counter
menun:  rmb     1               ; current menu selection
keycnt: rmb     1               ; key pressed counter for rapid counting
addrhi: rmb     1               ; wrmess address hi byte
addrlo: rmb     1               ; wrmess address lo byte
chrcnt: rmb     1               ; character count for wrmess
macnv:  rmb     2               ; data to convert
mbcnv:  rmb     2               ; data to convert
matemp: rmb     4               ; ASCII temporary value
mtemp:  rmb     1               ; General temporary value
mzfill: rmb     1               ; mainline Zero fill flag

mxobit: rmb     1               ; MX output bit counter
mxobyt: rmb     1               ; MX output byte
mxtxad: rmb     2               ; MX Transmit pointer
mx1bit: rmb     1               ; MX 1-bit counter (for bit stuffing)
mxsync: rmb     1               ; MX sync byte flag
mxstat: rmb     1               ; MX614 transmitter state machine state

ramff:  rmb     0               ; last entry (for address checking)

**************************************************************
**********     END OF $0040-$00ff RAM VARIABLES.    **********
********** THE REST HAVE TO USE EXTENDED ADDRESSING **********
************** $100-$1bf = 192 bytes for the app *************
*************** $1c0-$23f = 128 bytes for MYMON **************
**************************************************************

;Block           Length Total
;Rain Table      24     24
;Barometer Table 24     48
;Humidity        11     59
;Barometer data  14     73
;A/D conversions 2      75
;misc            4      79
;MX614 data      8      87
;Getext data     2      89
;AAG debug       4      93
;Peet Avg wspd   2      95

; Stack takes up the end of this space, save at least 20 bytes!

        org     ram100        ; start at $100

; The rain table is an array of 12 two-byte entries.  Each entry represents
; the rainfall count.  The first entry is for the most recent 5-minute
; interval while each successive entry is for an earlier 5-minute interval.
; The difference in rain count from the current rain count versus the last
; entry is roughly the rain over the past hour.  I need the big shift
; register of counts so that I can maintain a rough idea of the rain count
; on a sliding basis with 5-minute granularity.

rantbl: rmb     24              ; Rain table

; 24 bytes here

; The barometer table is an array of 12  entries.  Each entry contains ; the barometer
; sensor voltage output in binary, compressed.  The first entry is for the last
; 5 minute period.  Comparing the first voltage output to the last provides the
; information on pressure changes over the last hour.  12 entries provides 5 minute
; granularity.

bartbl: rmb     12              ; barometer table

dbbuf:  rmb     10              ; Debug buffer
dbptr:  rmb     1               ; Debug buffer pointer
hrroll: rmb     1               ; hours rolled flag (for debug)

; 24 bytes here

; Humidity sensor values

hmvcc:  rmb     2               ; humidity sensor VCC
hmvad:  rmb     2               ; humidity sensor voltage
hmtmp:  rmb     2               ; humidity sensor temperature
hmval:  rmb     1               ; Humidity value (MSB is warning flag)
hmtot:  rmb     2               ; Humidity totalized value
hmcnt:  rmb     1               ; Humidity sample count
hmdew:  rmb     1               ; Humidity calculated dewpoint

; 11 bytes here

; Barometer sensor values

bavad:  rmb     3               ; Barometer sensor voltage
bavalm: rmb     2               ; Barometer reading in Mb
baval:  rmb     3               ; Barometer reading in InHg
bacnt:  rmb     1               ; Barometer to count for 10 minutes
batot:  rmb     2               ; Barometer totalized value
errbar: rmb     1               ; Error count for Barometer
bartmp: rmb     2               ; Bar. temperature reaqding.

; 14 bytes here

; A/D conversion values

a2d1w:  rmb     1               ; 1-wire bus value (FS=5V)
a2dbty: rmb     1               ; Battery voltage (FS=15V)

; 2 bytes here

; misc flags

dtcal:  rmb     1               ; date/time recalibration flag (once per 24 hrs)
cdflag: rmb     1               ; Current/daily stats fla
maxw2:  rmb     2               ; Previous 5-minute max gust (for NOAA compatibility)

; 4 bytes here

; MX614 support (buffer in shared memory with the mymon app space.

mxptr:  rmb     2               ; big buffer pointer
mxscnt: rmb     1               ; MX614 transmitter state counter
mxiptr: rmb     1               ; MX buffer input pointer
mxoptr: rmb     1               ; MX state machine output pointer

mxoseq: rmb     1               ; MX output state

mxlst:  rmb     1               ; Flag for last byte address LSB

; 8 bytes here

; Getext temporary values
gtmxch: rmb     1               ; max characters to get
gtcch:  rmb     1               ; character index

; 2 bytes here

; Temporary space for AAG wind direction debug data
aagdbg: rmb     4               ; four A/D values

; Peet mode average wind speed (should be 1-minute, I cache 5-minute avg.
ptavws: rmb     2               ; Copy of 5-minute avg wind speed

; 4 bytes here

;       ****************** END OF APPLICATION RAM SPACE **********************
;       ****************** SHARED RAM WITH MYMON MONITOR *********************
;       ********* RAM USED HERE WILL BE TRASHED WHEN MYMON IS CALLED *********
;       **************** GOOD FOR THE TEMPORARY MX614 BUFFER! ****************
;       !!!!!!!!!!!!! MEANS MX614 BUFFER CANNOT EXCEED 128 BYTES !!!!!!!!!!!!!

        org     mnrapp          ; start of shared space with the debugger

mxbuf:  rmb     127             ; big buffer for entire message
;                               ;  9 bytes for the time
;                               ; 17 bytes for the position string (26 total)
;                               ; 33 bytes for the weather data (59 total)
;                               ;  3 bytes for the ID (62 total)
;                               ; 20 bytes for the debug data. (82 total)
;                               ; 31 bytes for the AX.25 header (113 total)
;                               ;  3 bytes for the AX.25 footer (116 total)

mxbnd:  rmb     1               ; last byte in the buffer

